﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml;

namespace XmlSaxWriting
{
    /*
     *       _____ _____ _____                _       _
     *      |_   _/  __ \_   _|              (_)     | |
     *        | | | /  \/ | |  ___  ___   ___ _  __ _| |
     *        | | ||      | | / __|/ _ \ / __| |/ _` | |
     *       _| |_| \__/\ | |_\__ \ (_) | (__| | (_| | |
     *      |_____\_____/ |_(_)___/\___/ \___|_|\__,_|_|
     *                   ___
     *                  |  _|___ ___ ___
     *                  |  _|  _| -_| -_|  LICENSE
     *                  |_| |_| |___|___|
     *
     * IT NEWS  <>  PROGRAMMING  <>  HW & SW  <>  COMMUNITY
     *
     * This source code is a part of online courses at IT social
     * network WWW.ICT.SOCIAL
     *
     * Feel free to use it for whatever you want, modify it and share it but
     * don't forget to keep this link in your code.
     *
     * Visit http://www.ict.social/licenses for more information
     */
    class Program
    {
        static void Main(string[] args)
        {
            // a collection of test users
            List<User> users = new List<User>();
            users.Add(new User("John Smith", 22, new DateTime(2000, 3, 21)));
            users.Add(new User("James Brown", 31, new DateTime(2016, 10, 30)));
            users.Add(new User("Tom Hanks", 16, new DateTime(2011, 1, 12)));

            // the XmlWriter settings
            XmlWriterSettings settings = new XmlWriterSettings();
            settings.Indent = true;

            // writes users
            using (XmlWriter xw = XmlWriter.Create(@"file.xml", settings))
            {
                xw.WriteStartDocument(); // the header
                xw.WriteStartElement("users"); // opens the root users element

                // writes individual users
                foreach (User u in users)
                {
                    xw.WriteStartElement("user");
                    xw.WriteAttributeString("age", u.Age.ToString());

                    xw.WriteElementString("name", u.Name);
                    xw.WriteElementString("registered", u.Registered.ToShortDateString());

                    xw.WriteEndElement();
                }

                xw.WriteEndElement(); // closes the root element
                xw.WriteEndDocument(); // closes the document
                xw.Flush();
            }
        }
    }
}
